/*
************************************************************************************************************************
*                                                         eGon2
*                                         the Embedded GO-ON Bootloader System
*
*                             Copyright(C), 2006-2008, SoftWinners Microelectronic Co., Ltd.
*											       All Rights Reserved
*
* File Name   : dynamic.c
*
* Author      : Jerry.Wang
*
* Version     : 1.1.0
*
* Date        : 2011-11-22
*
* Description :
*
* Others      : None at present.
*
*
* History     :
*
*  <Author>        <time>       <version>      <description>
*
* Jerry.Wang      2010-3-30       1.1.0        build the file
*
************************************************************************************************************************
*/
#include  "card_sprite_i.h"


typedef struct _tag_Dynamic_head
{
	u8   magic[8];   	// d 'y' 'n' 'a' 'm' 'i' 'c'
	u16  version;     	// 汾
	u16  count;        	// ݵĸ
	u32  tableOffset; 	// ƫ
	u32  dataOffset;  	// ݵƫ
	u32  sumCheck;   	// У
	u32  dataAlign;   	// ݶ
	u32  used;			// Ƿʹù
	u8   reserve[32];	// Ԥ
}Dyamic_head;


typedef struct _tag_Dynamic_Item	// 
{
	char name[16]; 		// ƣȲ16ַĳ
	char alians[16]; 	// Ȳ16ַĳ
	u32  nDataLen;		// ݳ
	u32  Checksum;		// У
	u8   reserve[24]; 	// Ԥ

}Dynamic_Item;


typedef struct _tag_Dynamic_index	//¼ùļͱ
{
	char magic[8];   	 // d 'y' 'n' 'a' 'm' 'i' 'c'
	char last_file[16];	 //ǰӦʹõļ
	int  total_count;	 //ܹļ
	int  used_count;	 //ʹùĴ
	int  err_times;		 //Ĵ
	int  successed_times;//ɹĴ
	int  reserved;
}Dynamic_index;


static __s32 dynamic_data_get(void *buffer, int size, void *dynamic_buffer, int dynamic_size);
//static __s32 simple_check_data_valid( void *mem_base, __u32 size );
//static __s32 simple_data_checksum(void *mem_base, __u32 size);

__s32 fetch_dynamic_data(char *buffer, int buffer_size)
{
	int		ret, i;
	H_FILE  index_file = NULL;
	H_FILE  data_file  = NULL;
	int     index_length;
	int     data_length;
	char    index_buffer[1024];
	char    *data_buffer;
	Dynamic_index  *dindex;
	char    data_file_name[32];
	Dyamic_head    *ddata;
	int		index_number;
	char    tmp_data_file_name[16];

	ret = -1;
//	if(wBoot_fsmount('Z'))		//ʵǹұ׼MBRû
//	{
//		__inf("log error: cant find user disk\n");
//
//		return;
//	}
	//ļ
	index_file = wBoot_fopen("z:\\dynamic\\dindex.bin", "rb+");
	if(!index_file)
	{
		sprite_wrn("dynamic data error: cant find dynamic data index file\n");

		goto dynamic_data_err;
	}
	index_length = wBoot_flen(index_file);
	if(!index_length)
	{
		sprite_wrn("dynamic data error: dynamic data index file is bad\n");

		goto dynamic_data_err;
	}
	//
	memset(index_buffer, 0, 1024);
	wBoot_fread(index_buffer, 1, index_length, index_file);
	dindex = (Dynamic_index *)index_buffer;
	//У
	if(memcmp(dindex->magic, "dynamic", sizeof("dynamic")))
	{
		sprite_wrn("dynamic data error: bad dynamic data index\n");

		goto dynamic_data_err;
	}
	//ļ
	memset(data_file_name, 0, 32);
	strcpy(data_file_name, "z:\\dynamic\\");

	while(dindex->used_count < dindex->total_count)
	{
		dindex->used_count ++;
		dindex->err_times ++;
		memset(tmp_data_file_name, 0, 16);
		strcpy(tmp_data_file_name, dindex->last_file);
		index_number = 0;
		for(i=1;(i<8) && (tmp_data_file_name[i] != '.');i++)
		{
			index_number = index_number * 10 + (tmp_data_file_name[i] - '0');
		}
		//浱ǰҪҵļ
		strcpy(data_file_name + sizeof("z:\\dynamic\\") - 1, dindex->last_file);
		//µļ
		index_number ++;
		for(i=7;i>0;i--)
		{
			tmp_data_file_name[i] = (index_number%10) + '0';
			index_number /= 10;
		}
		//дļ()
		strcpy(dindex->last_file, tmp_data_file_name);
		//ļ
		data_file = wBoot_fopen(data_file_name, "rb+");
		if(!data_file)
		{
			//Ӧļ
			sprite_wrn("dynamic data error: dynamic data file %s is not exist\n", data_file_name);
			data_file = NULL;

			continue;
		}
		data_length = wBoot_flen(data_file);
		if(!data_length)
		{
			sprite_wrn("dynamic data error: dynamic data file %s is bad\n", data_file_name);
			wBoot_fclose(data_file);
			data_file = NULL;

			continue;
		}
		data_buffer = wBoot_malloc(data_length);
		if(!data_buffer)
		{
			sprite_wrn("dynamic data error: not enough memory for dynamic data\n");

			goto dynamic_data_err;
		}
		wBoot_fread(data_buffer, 1, data_length, data_file);
		//ݵУ
//		if(simple_check_data_valid(data_buffer, data_length))
//		{
//			sprite_wrn("dynamic data error: dynamic data checksum error\n");
//			wBoot_free(data_buffer);
//			data_buffer = NULL;
//			wBoot_fclose(data_file);
//			data_file = NULL;
//
//			continue;
//		}
		ddata = (Dyamic_head *)data_buffer;
		if(ddata->used)	//Ѿʹùлһļ
		{
			wBoot_free(data_buffer);
			data_buffer = NULL;
			wBoot_fclose(data_file);
			data_file = NULL;
			wBoot_fclose(data_file);
		}
		else
		{
			ddata->used = 1;
			//ȡ
			dynamic_data_get(data_buffer, data_length, buffer, buffer_size);
			dindex->successed_times ++;
			dindex->err_times --;
			//ԭļ
//			simple_data_checksum(data_buffer, data_length);
			wBoot_fseek(data_file, 0, 0);
			wBoot_write(data_buffer, 1, data_length, data_file);
			wBoot_fclose(data_file);

			break;
		}
	}
	//޸ļ
	strcpy(dindex->last_file, tmp_data_file_name);
	wBoot_fseek(index_file, 0, 0);
	wBoot_write(index_buffer, 1, index_length, index_file);
	ret = 0;
	//
dynamic_data_err:
	if(data_buffer)
	{
		wBoot_free(data_buffer);
	}
	if(data_file)
	{
		wBoot_fclose(data_file);
	}
	if(index_file)
	{
		wBoot_fclose(index_file);
	}

	return ret;
}


//static __s32 simple_check_data_valid( void *mem_base, __u32 size )
//{
//	__u32 *buf;
//	__u32 count;
//	__u32 src_sum;
//	__u32 sum;
//	Dyamic_head    *ddata;
//
//	ddata = (Dyamic_head *)mem_base;
//
//	/* У */
//	src_sum = ddata->sumCheck;                  // Boot_file_headеġcheck_sumֶȡУ
//	ddata->sumCheck = 0;              		// STAMP_VALUEдBoot_file_headеġcheck_sumֶ
//
//	count = size >> 2;                      //  ֣4bytesΪλ
//	sum = 0;
//	buf = (__u32 *)mem_base;
//	do
//	{
//		sum += *buf++;                         // ۼӣУ
//		sum += *buf++;                         // ۼӣУ
//		sum += *buf++;                         // ۼӣУ
//		sum += *buf++;                         // ۼӣУ
//	}while( ( count -= 4 ) > (4-1) );
//
//	while( count-- > 0 )
//		sum += *buf++;
//
//	ddata->sumCheck = src_sum;                  // ָBoot_file_headеġcheck_sumֶεֵ
//
//	if( sum == src_sum )
//		return 0;               // Уɹ
//	else
//		return -1;                 // Уʧ
//}

//static __s32 simple_data_checksum(void *mem_base, __u32 size)
//{
//	Dyamic_head    *ddata;
//	__u32           *buf;
//	__u32            loop;
//	__u32            i;
//	__u32            sum;
//
//	ddata = (Dyamic_head *)mem_base;
//	buf = (__u32 *)mem_base;
//	ddata->sumCheck = 0;              // fill stamp
//	loop = size >> 2;
//    /* 㵱ǰļݵġУ͡*/
//    for( i = 0, sum = 0;  i < loop;  i++ )
//    	sum += buf[i];
//
//    /* write back check sum */
//    ddata->sumCheck = sum;
//
//    return 0;
//}

static __s32 dynamic_data_get(void *buffer, int size, void *dynamic_buffer, int dynamic_size)
{
	Dyamic_head 		*ddata;
	Dynamic_Item		*ditem;
	dynamic_data_form	*dform;
	dynamic_boot_head	*dhead;
	char			    *base;
	char				*d_base;
	int					 used_size;
	int					 item_size;
	int					 i;

	if(!dynamic_buffer)
	{
		return -1;
	}
	memset(dynamic_buffer, 0, dynamic_size);
	base  = (char *)buffer;
	ddata = (Dyamic_head *)buffer;
	used_size = 0;

	dhead = (dynamic_boot_head *)dynamic_buffer;
	d_base= (char *)dynamic_buffer + sizeof(dynamic_boot_head);

	memcpy(dhead->magic, "dynamic", sizeof("dynamic"));

	for(i=0;i<ddata->count;i++)
	{
		//̬ݶ׵ַ
		ditem = (Dynamic_Item *)(base + ddata->tableOffset + i * sizeof(Dynamic_Item));
		//ȡǰ̬ݼռõĳ
		item_size = sizeof(dynamic_data_form) + ditem->nDataLen;
		//ùܳ
		if(item_size & 0x03)
		{
			item_size = ((item_size + 4)>>2)<<2;
		}
		used_size += item_size;
		if(used_size > dynamic_size)
		{
			sprite_wrn("dynamic data error: not enough memory to store dynamic data\n");

			return -1;
		}
		dform = (dynamic_data_form *)d_base;
		memcpy(dform->name, ditem->name, 16);
		dform->datasize = ditem->nDataLen;
		dform->usedsize = ditem->nDataLen;
		if(dform->usedsize & 0x03)
		{
			dform->usedsize = ((dform->usedsize + 4)>>2)<<2;
		}
		memcpy(d_base + sizeof(dynamic_data_form), base + ddata->dataOffset + i * 512, ditem->nDataLen);
		d_base += sizeof(dynamic_data_form);
		d_base += dform->usedsize;

		dhead->count ++;
	}

	return 0;
}

